--- sys/kern/uipc_socket.c.orig	2010-04-02 13:36:19.000000000 +0300
+++ sys/kern/uipc_socket.c	2010-05-27 22:09:06.000000000 +0300
@@ -129,6 +129,7 @@ __FBSDID("$FreeBSD: src/sys/kern/uipc_so
 #include <sys/sysctl.h>
 #include <sys/uio.h>
 #include <sys/jail.h>
+#include <sys/syslog.h>
 
 #include <net/vnet.h>
 
@@ -656,8 +657,15 @@ soclose(struct socket *so)
 	if (so->so_state & SS_ISCONNECTED) {
 		if ((so->so_state & SS_ISDISCONNECTING) == 0) {
 			error = sodisconnect(so);
-			if (error)
+			if (error) {
+				if (error == ECONNRESET) {
+					log(LOG_INFO, 
+					    "ECONNRESET: so->state: 0x%x; file %s; line %d\n",
+					    so->so_state, __FILE__, __LINE__);
+					error = 0;
+				}
 				goto drop;
+			}
 		}
 		if (so->so_options & SO_LINGER) {
 			if ((so->so_state & SS_ISDISCONNECTING) &&